do_stylize.sh: prefer printf over echo -n for portability
[opendreambox.git] / scripts / do_stylize.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2010-2013 Dream Multimedia GmbH, Germany
4 #                         http://www.dream-multimedia-tv.de/
5 # Authors:
6 #   Andreas Oberritter <obi@opendreambox.org>
7 #
8 # Permission is hereby granted, free of charge, to any person obtaining a copy
9 # of this software and associated documentation files (the "Software"), to deal
10 # in the Software without restriction, including without limitation the rights
11 # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
12 # copies of the Software, and to permit persons to whom the Software is
13 # furnished to do so, subject to the following conditions:
14 #
15 # The above copyright notice and this permission notice shall be included in
16 # all copies or substantial portions of the Software.
17 #
18 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
19 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
20 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
21 # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
22 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
23 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
24 # THE SOFTWARE.
25 #
26
27 cleanup()
28 {
29         [ -z "$TEMP" ] || rm -f "$TEMP"
30 }
31
32 DEST=$1
33
34 if [ -z "$DEST" ]; then
35         echo "Usage: $0 <bbfile>"
36         exit 1
37 fi
38
39 TEMP=`mktemp` || {
40         echo "Fatal: Could not create temporary file."
41         exit 1
42 }
43
44 trap cleanup EXIT
45
46 GIT_ROOT=`git rev-parse --show-cdup 2>/dev/null` || {
47         echo "Fatal: You must run this script from a Git checkout."
48         exit 1
49 }
50
51 if [ -z "$GIT_ROOT" ]; then
52         GIT_ROOT="."
53 fi
54
55 if [ -f $GIT_ROOT/meta-openembedded/contrib/oe-stylize.py ]; then
56         OE_STYLIZE="$GIT_ROOT/meta-openembedded/contrib/oe-stylize.py"
57 elif [ -f $GIT_ROOT/../meta-openembedded/contrib/oe-stylize.py ]; then
58         OE_STYLIZE="$GIT_ROOT/../meta-openembedded/contrib/oe-stylize.py"
59 else
60         echo "Fatal: oe-stylize.py not found."
61         exit 1
62 fi
63
64 $OE_STYLIZE $DEST >> $TEMP
65
66 diff -u $DEST $TEMP
67 if [ $? -eq 0 ]; then
68         exit 0
69 fi
70
71 printf "Apply this patch? [Y/n] "
72 read ANSWER
73
74 if [ ! -z "$ANSWER" -a "$ANSWER" != "Y" -a "$ANSWER" != "y" ]; then
75         echo "Aborted."
76         exit 1
77 fi
78
79 chmod --reference=$DEST $TEMP
80 mv $TEMP $DEST
81 echo "Done."
82 exit 0